﻿using System.ComponentModel;

namespace WisejKendoRatingExample
{
	public class KendoRatingControl : Wisej.Web.Widget
	{
		public KendoRatingControl()
		{
			InitializeComponent();
		}

		public int Value
		{
			get
			{
				return valueInternal;
			}
			set
			{
				valueInternal = value;
				this.Call("update", valueInternal);
			}
		}
		private int valueInternal = 0;

		protected override void OnWebEvent(Wisej.Core.WisejEventArgs e)
		{
			if (e.Type == "widgetEvent" && e.Parameters.Event.type == "change")
			{
				if (e.Parameters.Event.data.value != null)
				{
					valueInternal = e.Parameters.Event.data.value;
					var args = new KendoRatingEventArgs(valueInternal);
					OnRatingUpdate(args);
				}
			}
		}

		#region Events
		/// <summary>
		/// Fired when the KendoRating sends a change request.
		/// </summary>
		[Category("KendoRating")]
		public event KendoRatingEventHandler RatingUpdate;

		/// <summary>
		/// Fires the <see cref="RatingUpdate"/> event.
		/// </summary>
		/// <param name="e"></param>
		protected virtual void OnRatingUpdate(KendoRatingEventArgs e)
		{
			this.RatingUpdate?.Invoke(this, e);
		}
		#endregion

		private void InitializeComponent()
		{
			System.ComponentModel.ComponentResourceManager resources = new System.ComponentModel.ComponentResourceManager(typeof(KendoRatingControl));
			Wisej.Web.Widget.Package package1 = new Wisej.Web.Widget.Package();
			Wisej.Web.Widget.Package package2 = new Wisej.Web.Widget.Package();
			Wisej.Web.Widget.Package package3 = new Wisej.Web.Widget.Package();
			this.SuspendLayout();
			// 
			// KendoRatingControl
			// 
			this.InitScript = resources.GetString("$this.InitScript");
			this.Name = "KendoRatingControl";
			package1.Name = "kendo.default-main.min.css";
			package1.Source = "https://kendo.cdn.telerik.com/2021.3.914/styles/kendo.default-main.min.css";
			package2.Name = "jquery.min.js";
			package2.Source = "https://kendo.cdn.telerik.com/2021.3.914/js/jquery.min.js";
			package3.Name = "kendo.all.min.js";
			package3.Source = "https://kendo.cdn.telerik.com/2021.3.914/js/kendo.all.min.js";
			this.Packages.Add(package1);
			this.Packages.Add(package2);
			this.Packages.Add(package3);
			this.Size = new System.Drawing.Size(183, 42);
			this.ResumeLayout(false);

		}
	}
}